 ## -*- texinfo -*-
## @deftypefn  {Function File} {} @var{c} = rainflow(@var{x})
## @deftypefnx {Function File} {} @var{c} = rainflow(@var{x},@var{fs})
## @deftypefnx {Function File} {} @var{c} = rainflow(@var{x},@var{t})
## @deftypefnx  {Function File} {} @var{c} = rainflow(@var{xt})
## @deftypefnx  {Function File} {} @var{c} = rainflow(@dots{},'ext')
## @deftypefnx  {Function File} {} [@var{c},@var{rm},@var{rmr},@var{rmm}] = rainflow(@dots{})
## @deftypefnx  {Function File} {} [@var{c},@var{rm},@var{rmr},@var{rmm},@var{idx}] = rainflow(@dots{})
## @deftypefnx  {Function File} {} rainflow(@dots{})
## @end deftypefn
function c=rainflow(x,varargin)
  if (nargin < 1 || nargin > 3 ||  (nargout>1 &&  nargout<4) ||  nargout>5)
          print_usage ();
  elseif (nargout~=1 || nargin == 3)
           error ("Current, only c=rainflow(x), c=rainflow(x,fs) and c=rainflow(x,t) are available\n");
  elseif(!DataValidation (x))
     error ("x must be signal or double and finite\n");
   endif
  ext=0;
  t=[1:length(x)];
   switch nargin
    case 2
        if (isnumeric (varargin{1}))
          if(isscalar(varargin{1}))
            fs=varargin{1};
            %check frequency
            FrequencyValidation(fs);
            t=[0:length(x)-1]/fs;
        else
          t=varargin{1};
          endif
         else
          if(!strcmp(varargin{1},'ext'))
          print_usage ();
        endif
        ext=1;
        endif
  case 3
    ext=1;
        if (isnumeric (varargin{1}))
          if(isscalar(varargin{1}))
            fs=varargin{1};
            %check frequency
            FrequencyValidation(fs);
            t=[0:length(x)-1]/fs;
        else
          t=varargin{1};
          endif
         else
          print_usage ();
        endif
       if(!strcmp(varargin{2},'ext'))
          print_usage ();
        endif

end
   % defualt value of ext


   % Find local maxima
   [maxpks,maxlocs] = findpeaks(x-min(x));
   % Find local minima
   [minpks,minlocs] = findpeaks(-x+max(x));
   %  peaks locations
   if(size(minlocs,2)==1)
   locs=[1 maxlocs' minlocs' length(x)];
 else
   locs=[1 maxlocs minlocs length(x)];
   end

    locs=sort(locs);

    c=rainflowAlgorthim(t(locs),x(locs));
  endfunction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  function c=rainflowAlgorthim(t,D)
      Reversals=[1:3];
      Z=1;
      cycle=[];
      Range=[];
      Start=[];
      EEnd=[];
      MMean=[];
while(1)

if(length(Reversals)<3)
% Read Next Reversal
Reversals=[Reversals Reversals(end)+1];
  %check if it is out the data
  if (Reversals(end)>=length(D))
    [cycle,Range,Start,EEnd,MMean]=outofData(cycle,Range,Start,EEnd,MMean,D,Reversals,t);
    break;
  endif
else

n=length(Reversals)-3;
Y=Reversals([1+n 2+n]);
X=Reversals([2+n 3+n]);

ry=abs(D(Y(2))-D(Y(1)));
rx=abs(D(X(2))-D(X(1)));
if(ry>rx)
% Read Next Reversal
if (Reversals(end)<length(D))
Reversals=[Reversals Reversals(end)+1];
else
%end
  %check if it is out the data
 % if (Reversals(end)>length(D))
    [cycle,Range,Start,EEnd,MMean]=outofData(cycle,Range,Start,EEnd,MMean,D,Reversals,t);
          k=1;%find(Reversals==Y(1));
          Reversals(k)=[];
  endif
else

 if (any(Y(:)==Z))

          k=find(Reversals==Y(1));
          Reversals(k)=[];
          cycle(end+1)=0.5;
          Range(end+1)=ry;
          Start(end+1)=t(Y(1));
          EEnd(end+1)=t(Y(2));
          MMean(end+1)=(D(Y(2))+D(Y(1)))/2;

          Z=Y(2);
        else
          cycle(end+1)=1;
           Range(end+1)=ry;
            Start(end+1)=t(Y(1));
          EEnd(end+1)=t(Y(2));
           MMean(end+1)=(D(Y(2))+D(Y(1)))/2;
          k=find(Reversals==Y(1));
          Reversals(k)=[];
            k=find(Reversals==Y(2));
          Reversals(k)=[];

        end


endif

endif
end
c=[cycle'  Range' MMean' Start' EEnd'];
endfunction

%%------------------------------------
function [cycle,Range,Start,EEnd,MMean]=outofData(cycle,Range,Start,EEnd,MMean,D,Reversals,t)
   cycle(end+1)=0.5;
   Range(end+1)=abs(D(Reversals(2))-D(Reversals(1)));
   Start(end+1)=t(Reversals(1));
   EEnd(end+1)=t(Reversals(2));
   MMean(end+1)=(D(Reversals(2))+D(Reversals(1)))/2;

endfunction
%%-------------------------------------



  function check = DataValidation (x)

  %Types={'single ',' double '};

  check  = ((isnumeric (x) || isinteger (x) || isfloat(x)) && ! issparse (x) && ! isempty (x) && isreal (x) && !any(isinf(x(:))==1) && !any(isnan(x(:))==1));
endfunction

%%--------------------------------------
function FrequencyValidation(fs)
  if (fs<0)
     error ("fs must be positive real scalar\n");
     endif

  endfunction
